Program Dragon;

{ Dragon's Fly - Copyright (C) 2K by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

Uses
 Trigo,Mode13;

Const
 Age   =25;

 Width =50;
 Height=80;
 Depth =40;

 Size:array[1..3*8] of integer=(
  -1,-1,+1,
  +1,-1,+1,
  -1,+1,+1,
  +1,+1,+1,
  -1,-1,-1,
  +1,-1,-1,
  -1,+1,-1,
  +1,+1,-1
 );

 Edge:array[0..3*12-1] of word=(
  0,2,1, 1,2,3,
  4,5,6, 5,7,6,
  0,1,4, 4,1,5,
  6,7,2, 2,7,3,
  0,4,6, 6,2,0,
  7,5,1, 7,1,3
 );

 VerticeCount=Age*8;
 FaceCount   =Age*12;

Var
 Vertices:array[0..VerticeCount-1] of TVertice;
 Coords  :array[0..VerticeCount-1] of TCoord;
 VNormals:array[0..VerticeCount-1] of TVertice;
 VertNorm:array[0..VerticeCount-1] of TVector;
 Faces   :array[0..FaceCount-1] of TFace;
 FNormals:array[0..FaceCount-1] of TVertice;
 FaceNorm:array[0..FaceCount-1] of TVector;

 FaceList:array[0..FaceCount-1] of integer;
 DeltaZ  :array[0..FaceCount-1] of longint;

 d,dv,df,v,f:integer;
 vc,fc:integer;

 phix,phiy,phiz:byte;
 phia,phib,phic:byte;
 da,db,dc:integer;

 pal:TPalette;

 time:longint;
 ticks:longint absolute $40:$6C;


procedure QuickSort(left,right:word);
 var
  i,j:word;
  x,y:longint;
 begin
  i:=left;
  j:=right;
  x:=deltaz[(left+right+1)shr 1];
  repeat
   while (deltaz[i]>x) do inc(i);
   while (x>deltaz[j]) do dec(j);
   if (i<=j) then begin
    y:=deltaz[i]; deltaz[i]:=deltaz[j]; deltaz[j]:=y;
    y:=facelist[i]; facelist[i]:=facelist[j]; facelist[j]:=y;
    inc(i);
    dec(j);
   end;
  until i>j;
  if (left<j) then quicksort(left,j);
  if (i<right) then quicksort(i,right);
 end;

function Shade(const vector:TVector):integer;
 begin
  Shade:=32+((Light.x*Vector.x)+(Light.y*Vector.y)+(Light.z*Vector.z*3 div 4));
 end;

function Faced(const vector:TVector):boolean;
 begin
  with vector do Faced:=(Light.x*x+Light.y*y+Light.z*z)>=0
 end;

procedure DrawWorld;
 var
  i:word;
 begin
  clear;

  for i:=0 to FaceCount-1 do begin
   FaceList[i]:=i;
   with Faces[i] do deltaZ[i]:=longint(Coords[a].z+Coords[b].z+Coords[c].z) div 3;
  end;

  QuickSort(0,FaceCount-1);

  for i:=0 to FaceCount-1 do begin
   with Faces[FaceList[i]] do begin
    If (*Faced*)(FaceNorm[FaceList[i]].z>=0) then
    xpoly(coords[a].x,coords[a].y,Shade(VertNorm[a]),
          coords[b].x,coords[b].y,Shade(VertNorm[b]),
          coords[c].x,coords[c].y,Shade(VertNorm[c]));
   end;
  end;

  swap;
 end;

begin
{ Build Dragon Vertices & Faces }
 for d:=0 to Age-1 do begin

  dv:=8*d;
  Move(Size,Vertices[dv],SizeOf(Size));
  for v:=0 to 7 do begin
   With Vertices[dv+v] do begin
    x:=x*(Width -2*d);
    y:=y*(Height-2*d);
    z:=z*(Depth -2*d)+Depth;
   end;
  end;

  df:=12*d;
  Move(Edge,Faces[df],SizeOf(Edge));
  for f:=0 to 11 do begin
   With Faces[df+f] do begin
    inc(a,dv);
    inc(b,dv);
    inc(c,dv);
   end;
  end;

 end;

 Normals(Faces,Vertices,FNormals,VNormals,32);

{ Graph Stuffs }
 for f:=0 To 63 Do begin
  pal[f,0]:=f div 1;
  pal[f,1]:=f div 32;
  pal[f,2]:=f div 32;
 end;

 initgraph;
 setpalette(pal);

 with Light do begin x:=0; y:=0; z:=1; end;

 phix:=0;
 phiy:=64;
 phiz:=10;

 phia:=0; da:=1;
 phib:=0; db:=1;
 phic:=5; dc:=1;

 repeat

 time:=ticks;

 Move(Vertices,Coords,SizeOf(Coords));
 Move(VNormals,VertNorm,SizeOf(VNormals));
 Move(FNormals,FaceNorm,SizeOf(FNormals));
 vc:=0;
 fc:=0;

 if phia<16 then begin
  if phic<5 then inc(phic)
 end else begin
  if phic>0 then dec(phic);
 end;

 for d:=Age-1 downto 0 do begin
  dv:=8*d;
  df:=12*d;
  inc(vc,8);
  inc(fc,12);
  { Rotate Age# }
  InitTrigo(phia,phib,phic);
  Rotate(@Coords[dv],@Coords[dv],vc);
  Rotate(@VertNorm[dv],@VertNorm[dv],vc);
  Rotate(@FaceNorm[df],@FaceNorm[df],fc);
  { Translate }
  if d>0 then Translate(0,0,2*Depth-3*d,@Coords[dv],@Coords[dv],vc);
 end;

 InitTrigo(PhiX,PhiY,PhiZ);
 Rotate(@Coords[dv],@Coords[dv],VerticeCount);
 Translate(0,0,0,@Coords[dv],@Coords[dv],VerticeCount);
 Rotate(@VertNorm,@VertNorm,VerticeCount);
 Rotate(@FaceNorm,@FaceNorm,FaceCount);

 Project(@Coords,VerticeCount);
 DrawWorld;
 inc(phix,1);
(*
 inc(phiy,2);
 inc(phiz,1);
*)
 inc(phia,da); if (phia>16)and(phia<240) then da:=-da;

 repeat until ticks-time > 0;

 until port[$60]=1;

 closegraph;

end.