Unit Mode13;

{ Dragon's Fly - Copyright (C) 2K by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

interface

Type
 TPalette=array[0..255,0..2] of byte;

procedure initgraph;
procedure closegraph;
procedure clear;
procedure swap;
procedure SetPalette(Var Palette);
procedure poly(x1,y1,x2,y2,x3,y3,color:integer);
procedure xpoly(x1,y1,c1,x2,y2,c2,x3,y3,c3:integer);

Var
 SwapSeg:word;

implementation

Var
 SwapScreen:pointer;
 XLeft,XRight:array[0..199] of word;
 CLeft,CRight:array[0..199] of byte;


procedure initgraph;
 begin
  asm mov ax,13h; int 10h end;
  getmem(SwapScreen,320*200);
  SwapSeg:=Seg(SwapScreen^);
 end;

procedure closegraph;
 begin
  asm mov ax,03h; int 10h end;
  freemem(SwapScreen,320*200);
 end;

procedure clear; assembler;
 asm
  les di,SwapScreen
  xor ax,ax
  mov cx,320*200/2
  rep stosw
 end;

procedure Swap; assembler;
 asm
  push ds
   mov es,SegA000
   xor di,di
   lds si,SwapScreen
   mov cx,320*200/2
   rep movsw
  pop  ds
 end;

procedure SetPalette(Var Palette); assembler;
 asm
  push ds
   lds si,Palette
   mov cx,3*255
   mov dx,$3c8
   mov al,0
   out dx,al
   inc dx
  @SetDAC:
   lodsb
   out dx,al
  Loop @SetDAC
  pop  ds
 end;

procedure ClearLR; assembler;
 asm
  mov ax,SEG @Data
  mov es,ax
  mov di,Offset XLeft
  mov si,Offset XRight
  xor ax,ax
  mov bx,319
  mov dx,2
  mov cx,200
 @Next:
  mov es:[si],ax
  mov es:[di],bx
  add si,dx
  add di,dx
 Loop @Next
 end;

function min(a,b:integer):integer; assembler;
 asm
  mov ax,a
  cmp ax,b
  jle @done
   mov ax,b
  @done:
 end;

function max(a,b:integer):integer; assembler;
 asm
  mov ax,a
  cmp ax,b
  jae @done
   mov ax,b
  @done:
 end;

procedure Scan(x1,y1,x2,y2:integer);
 var
  dx,dy:integer;
  ix,iy:integer;
  i,e:integer;
 begin
  dx:=x2-x1; if dx<0 then begin dx:=-dx; ix:=-1 end else ix:=1;
  dy:=y2-y1; if dy<0 then begin dy:=-dy; iy:=-1 end else iy:=1;

  if dx>dy then begin

   e:=dy;
   for i:=0 to dx do begin
    if x1<XLeft[y1] then XLeft[y1]:=x1;
    if x1>XRight[y1] then XRight[y1]:=x1;
    inc(e,dy);
    if e>dx then begin
     dec(e,dx);
     inc(y1,iy);
    end;
    inc(x1,ix);
   end;

  end else begin

   e:=dx;
   for i:=0 to dy do begin
    if x1<XLeft[y1] then XLeft[y1]:=x1;
    if x1>XRight[y1] then XRight[y1]:=x1;
    inc(e,dx);
    if e>dy then begin
     dec(e,dy);
     inc(x1,ix);
    end;
    inc(y1,iy);
   end;

  end;
 end;

procedure Poly(x1,y1,x2,y2,x3,y3,color:integer);
 var
  miny,maxy:word;
  y,x,c:integer;
  o:word;
 begin
  ClearLR;
  miny:=max(min(y1,min(y2,y3)),0);   if miny>199 then exit;
  maxy:=min(max(y1,max(y2,y3)),199); if maxy<0   then exit;
  scan(x1,y1,x2,y2);
  scan(x2,y2,x3,y3);
  scan(x1,y1,x3,y3);
  o:=320*miny;
  for y:=miny to maxy do begin
   if XLeft[y]<=XRight[y] then begin
    x:=XLeft[y];
    c:=XRight[y];
    asm
     les di,SwapScreen
     mov ax,Color
     add di,o
     add di,x
     mov cx,c
     sub cx,x
     jz  @OnePixel
     rep stosb
     @OnePixel:
     stosb
    end;
   end;
   inc(o,320);
  end;
 end;

procedure xscan(x1,y1,c1,x2,y2,c2:integer);
 var
  dtx,dy,dc:integer;
  ix,ic,ii:integer;
  ex,ey,ec,ee:integer;

  x,y,c:integer;
 begin
  if (y1>y2) then begin
   dtx:=x1; x1:=x2; x2:=dtx;
   dy:=y1; y1:=y2; y2:=dy;
   dc:=c1; c1:=c2; c2:=dc;
  end;

  dtx:=x2-x1; if dtx<0 then begin ix:=-1; dtx:=-dtx end else ix:=1; ex:=dtx;
  dy:=y2-y1; ey:=dy;
  dc:=c2-c1; if dc<0 then begin ic:=-1; dc:=-dc end else ic:=1; ec:=dc;

  ee:=max(ex,max(ey,ec));

  if ee=0 then exit;
{ $define asm}
{$ifdef asm}
  asm
   mov ax,ee
   mov bx,x1

   mov di,y1
   mov si,di
   add si,di

   mov cx,ax
   @MainLoop:

    cmp ex,ax
    jbe @skipx
     sub ex,ax
     add bx,ix
    @skipx:

    cmp ec,ax
    jbe @skipc
     sub ec,ax
     mov dx,ic
     add c1,dx
    @skipc:

    cmp ey,ax
    jbe @skipy
     sub ey,ax

     mov dx,c1

     cmp bx,[si+offset XLeft]
     jge @skipleft
      mov [si+offset Xleft],bx
      mov [di+offset Cleft],dl
     @skipleft:

     cmp bx,[si+offset XRight]
     jle @skipright
      mov [si+offset XRight],bx
      mov [di+offset CRight],dl
     @skipright:

     add si,2
     inc di

    @skipy:

    mov dx,dtx
    add ex,dx

    mov dx,dy
    add ey,dx

    mov dx,dc
    add ec,dx

   loop @MainLoop
  end;

{$else}

  for ii:=0 to ee do begin
   asm
    mov ax,ee

    cmp ex,ax
    jbe @skipx
     sub ex,ax
     mov bx,ix
     add x1,bx
    @skipx:

    cmp ec,ax
    jbe @skipc
     sub ec,ax
     mov bx,ic
     add c1,bx
    @skipc:

  (*
   if ex>ee then begin
    dec(ex,ee);
    inc(x1,ix);
   end;

   if ec>ee then begin
    dec(ec,ee);
    inc(c1,ic);
   end;
   if ey>ee then begin
    dec(ey,ee);
  *)
     cmp ey,ax
     jbe @skipy

     sub ey,ax

     mov di,y1
     mov si,di
     add si,di

     mov bx,x1
     mov dx,c1

     cmp bx,[si+offset XLeft]
     jge @skipleft
      mov [si+offset Xleft],bx
      mov [di+offset Cleft],dl
     @skipleft:

     cmp bx,[si+offset XRight]
     jle @skipright
      mov [si+offset XRight],bx
      mov [di+offset CRight],dl
     @skipright:
   (*
    if x1<XLeft[y1] then begin
     XLeft[y1]:=x1;
     CLeft[y1]:=c1;
    end;
    if x1>XRight[y1] then begin
     XRight[y1]:=x1;
     CRight[y1]:=c1;
    end;
    inc(y1);
   end;
   *)
     inc y1

    @skipy:

    mov bx,dtx
    add ex,bx

    mov bx,dy
    add ey,bx

    mov bx,dc
    add ec,bx
   end;
   (*
   inc(ex,dx);
   inc(ey,dy);
   inc(ec,dc);
   *)
  end;
{$endif}
 end;

(*
procedure xpoly(x1,y1,c1,x2,y2,c2,x3,y3,c3:integer);
 var
  miny,maxy:word;
  y:word;
  xl,xr,cl,cr,c,dc:integer;
 begin
  miny:=max(min(y1,min(y2,y3)),0);   if miny>199 then exit;
  maxy:=min(max(y1,max(y2,y3)),199); if maxy<0   then exit;

  ClearLR;
  xscan(x1,y1,c1,x2,y2,c2);
  xscan(x2,y2,c2,x3,y3,c3);
  xscan(x3,y3,c3,x1,y1,c1);

  for y:=miny to maxy do
   if XLeft[y]<XRight[y] then begin
    xl:=XLeft[y]; xr:=XRight[y];
    cl:=CLeft[y]; cr:=CRight[y];
    dc:=(cr-cl) shl 6;
    if (xr<>xl) then dc:=dc div (xr-xl);
    c:=cl shl 6;
    asm
     les di,SwapScreen
     mov ax,y
     mov bx,ax
     shl ax,8
     shl bx,6
     add ax,bx
     add ax,xl
     add di,ax

     mov ax,c
     mov bx,dc

     mov cx,xr
     sub cx,xl
    @Next:
     mov si,ax
     shr ax,6
     stosb
     mov ax,si
     add ax,bx
    loop @next
    end;
   end;

 end;
*)
procedure xPoly(x1,y1,c1,x2,y2,c2,x3,y3,c3:integer);
 var
  miny,maxy:integer;
  y:integer;
  o:word;
  x,e,i:integer;
 begin
  ClearLR;
  miny:=max(min(y1,min(y2,y3)),0);   if miny>199 then exit;
  maxy:=min(max(y1,max(y2,y3)),199); if maxy<0   then exit;

  xscan(x1,y1,c1,x2,y2,c2);
  xscan(x2,y2,c2,x3,y3,c3);
  xscan(x1,y1,c1,x3,y3,c3);

  o:=320*miny;

  for y:=miny to maxy do begin
   if XLeft[y]<=XRight[y] then begin
    c1:=CLeft[y];
    c2:=CRight[y];
    c3:=c2-c1;     if c3<0 then begin c3:=-c3; i:=-1 end else i:=+1;

    x1:=XLeft[y];
    x2:=XRight[y];
    x3:=x2-x1;


    if x3>c3 then begin
     e:=c3;
     for x:=x1 to x2 do begin
      mem[Seg(SwapScreen^):o+x]:=c1;
      inc(e,c3);
      if e>x3 then begin
       dec(e,x3);
       inc(c1,i);
      end;
     end;
    end else begin
     e:=x3;
     for x:=0 to c3 do begin
      mem[Seg(SwapScreen^):o+x1]:=c1;
      inc(e,x3);
      if e>c3 then begin
       dec(e,c3);
       inc(x1);
      end;
      inc(c1,i);
     end;
    end;
   {
    x:=XLeft[y];
    c:=XRight[y];
    asm
     les di,SwapScreen
     mov ax,Color
     add di,o
     add di,x
     mov cx,c
     sub cx,x
     jz  @OnePixel
     rep stosb
     @OnePixel:
     stosb
    end;
   }
   end;
   inc(o,320);
  end;
 end;

end.